extends ../_docs-template

block vars
  - var activeLink = 'react';
  - var title = 'Sheet Modal React Component | Framework7 React Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-react
  .docs-content
    .motion-docs-page-title
      h1 Sheet Modal React Component
      script(src="/js/motion/sheet.js")
      f7-motion-sheet(motion)

    p Sheet Modal is a special overlay type which is similar to Picker/Calendar's overlay. Such modal allows to create custom picker overlays with custom content.
    p Sheet Modal React component represents <a href="../docs/sheet-modal.html">Sheet Modal</a> component.
    h2 Sheet Modal Components
    p There are following components included:
    ul
      li `Sheet`  - sheet modal element
    h2 Sheet Modal Properties
    table.params-table.cols-3
      thead
        tr
          th Prop
          th Type
          th Description
      tbody
        tr
          th(colspan="3") &lt;Sheet&gt; properties
        tr
          td position
          td string
          td Sheet position, can be `top` or `bottom`. By default is `bottom`
        tr
          td top
          td boolean
          td Same as `position="top"`
        tr
          td bottom
          td boolean
          td Same as `position="bottom"`
        tr
          td backdrop
          td boolean
          td Enable to render additional sheet modal backdrop when required
        tr
          td backdropEl
          td string<br>object
          td HTML element or string CSS selector of custom backdrop element
        tr
          td backdropUnique
          td boolean
          td If enabled it creates unique backdrop element exclusively for this modal
        tr
          td opened
          td boolean
          td Allows to open/close Sheet Modal and set its initial state
        tr
          td closeByBackdropClick
          td boolean
          td When enabled, sheet will be closed on backdrop click. By default inherits same app parameter value
        tr
          td closeByOutsideClick
          td boolean
          td When enabled, sheet will be closed on when click outside of it. By default inherits same app parameter value
        tr
          td closeOnEscape
          td boolean
          td When enabled, sheet will be closed on ESC keyboard key press
        tr
          td swipeToClose
          td boolean
          td Whether the Sheet can be closed with swipe gesture
        tr
          td swipeToStep
          td boolean
          td When enabled it will be possible to split opened sheet into two states: partially opened and fully opened that can be controlled with swipe
        tr
          td swipeHandler
          td HTMLElement<br>string
          td If not passed, then whole Sheet can be swiped to close. You can pass here HTML element or string CSS selector of custom element that will be used as a swipe target. (`swipeToClose` or `swipeToStep` must be also enabled)
        tr
          td push
          td boolean
          td When enabled it will push view behind on open. Works only when top safe area is in place. It can also be enabled by adding `sheet-modal-push` class to Sheet element.
        tr
          td animate
          td boolean
          td Whether the modal should be opened/closed with animation or not
        tr
          td containerEl
          td HTMLElement<br>string
          td Element to mount modal to (default to app root element)

    h2 Sheet Modal Events
    table.events-table
      thead
        tr
          th Event
          th Description
      tbody
        tr
          th(colspan="2") &lt;Sheet&gt; events
        tr
          td sheetOpen
          td Event will be triggered when Sheet Modal starts its opening animation
        tr
          td sheetOpened
          td Event will be triggered after Sheet Modal completes its opening animation
        tr
          td sheetClose
          td Event will be triggered when Sheet Modal starts its closing animation
        tr
          td sheetClosed
          td Event will be triggered after Sheet Modal completes its closing animation
        tr
          td sheetStepOpen
          td Event will be triggered on Sheet swipe step open/expand
        tr
          td sheetStepClose
          td Event will be triggered on Sheet swipe step close/collapse
        tr
          td sheetStepProgress
          td Event will be triggered on Sheet swipe step between step opened and closed state. As `event.detail` it receives step open progress number (from `0` to `1`)

    h2 Sheet Modal Slots
    p `<Sheet>` component has additional slots for custom elements:
    ul
      li `default` - element will be inserted as a child of scrollable `<div class="sheet-modal-inner">` element
      li `static` - same as `default`
      li `fixed` - element will be inserted before the scrollable `<div class="sheet-modal-inner">` element

    ```jsx
      <Sheet>
        <span slot="fixed">Fixed slot</span>
        <span slot="static">Static slot</span>
        <span>Default slot</span>
      </Sheet>
    ```
    p Renders to
    ```html
      <div class="sheet-modal">
        <span>Fixed slot</span>
        <div class="sheet-modal-inner">
          <span>Default slot</span>
          <span>Static slot</span>
        </div>
      </div>
    ```

    h2 Open And Close Sheet Modal
    p You can control Sheet Modal state, open and closing it:
    ul
      li using its <a href="../docs/sheet-modal.html">Sheet Modal API</a>
      li by passing `true` or `false` to its `opened` prop
      li by clicking on <a href="link.html">Link</a> or <a href="button.html">Button</a> with relevant `sheetOpen` property (to open it) and `sheetClose` property to close it

    h2 Examples
    +examplePreview('react', 'sheet-modal.jsx', 'sheet-modal')
